-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

--[[local M = {}

local helper = require('scenario/scenariohelper')
local running = false

local checkForPlayerStop = false
local playerMinimumSpeed = 0.5 --m/s
local playerStopTimeout = 0 --s
local playerStopMaxTimeout = 10 --s

local function reset()
    checkForPlayerStop = false
    playerStopTimeout = 0
    running = false
end

local function fail(reason)
    reset()
    scenarios.finish({failed = reason})
end

local function onRaceStart()
    reset()

    helper.trackVehicle('scenario_player0', 'playerCar')
helper.queueLuaCommandByName('scenario_player0', 'drivetrain.fuel = 0.33')

    running = true
end

local function onRaceTick(raceTickTime)
    if not running then
        return
    end

    local carData = map.objects[map.objectNames['playerCar'] ]
    if not carData then
        return
    end

    local speed = carData.vel:length()
    --Check if the player has passed the minimum speed before start watching his speed
    if not checkForPlayerStop and speed > playerMinimumSpeed then
        checkForPlayerStop = true
    end

    --Count down the player when he's below the minimum speed
    if checkForPlayerStop and (speed < playerMinimumSpeed) then
        playerStopTimeout = playerStopTimeout + raceTickTime
        if playerStopTimeout % 1 == 0 then
            local countdown = playerStopMaxTimeout - math.modf(playerStopTimeout)
            if countdown > 0 then
                helper.flashUiMessage(countdown..'...', 0.5, true)
            end
        end
    else
        playerStopTimeout = 0
    end

    if playerStopTimeout >= playerStopMaxTimeout then -- wait x seconds
        fail('You got stuck or ran out of fuel')
    end
end

M.onRaceStart = onRaceStart
M.onRaceTick = onRaceTick

return M
--]]--]]